unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  math, windows, LCLType, LCLIntf, Classes, SysUtils, FileUtil, Forms, Controls,
  Graphics, Dialogs, ExtCtrls, StdCtrls, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    FSEScaleX: TFloatSpinEdit;
    FSEScaleY: TFloatSpinEdit;
    FSEOblique: TFloatSpinEdit;
    FSERotate: TFloatSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure GDIPaintProc(Sender: TObject);
    procedure _onCreate(Sender: TObject);
    procedure _repaint(Sender: TObject);
  private
    ResultTransform:XFORM;
    { private declarations }
  public
    { public declarations }
  end;

  function AddFontResourceEx(_para1:LPCSTR; flags:DWORD; reserved:Pointer) : integer; stdcall; external 'gdi32' name 'AddFontResourceExA';

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.GDIPaintProc(Sender: TObject);
const
  ident:XFORM=(eM11:1;eM12:0;eM21:0;eM22:1;eDx:0;eDy:0);
  x=100;
  y=100;
  MWT_Mode=MWT_RIGHTMULTIPLY;
var
  r:trect;
  transminusM,obliqueM,transplusM,scaleM,rotateM:XFORM;
  txtOblique,txtRotate,txtSx,txtSy:single;
  lfcp:TLogFont;
  DummyDrawerHandle:thandle;

begin

     lfcp.lfHeight:=30;
     lfcp.lfWidth:=0;
     lfcp.lfEscapement:=0;
     lfcp.lfOrientation:=0;
     lfcp.lfWeight:=FW_NORMAL;
     lfcp.lfItalic:=0;
     lfcp.lfUnderline:=0;
     lfcp.lfStrikeOut:=0;
     lfcp.lfCharSet:=0;
     lfcp.lfOutPrecision:=0;
     lfcp.lfClipPrecision:=0;
     lfcp.lfQuality:=0;
     lfcp.lfPitchAndFamily:=0;
     lfcp.lfFaceName:='OpenGost Type B TT';

     DummyDrawerHandle:=CreateFontIndirect(lfcp);
     SelectObject(TPanel(Sender).canvas.Handle,DummyDrawerHandle);

     {draw reference string}
     SetBkMode(TPanel(Sender).canvas.Handle,TRANSPARENT);
     SetTextAlign(TPanel(Sender).canvas.Handle,TA_BOTTOM or TA_LEFT);
     ExtTextOut(TPanel(Sender).canvas.Handle,100,100,{Options: Longint}0,@r,'This is not OpenGost Type B TT',-1,nil);

     {draw transformed string}
     txtOblique:=pi/2-FSEOblique.Value*pi/180;
     txtRotate:=FSERotate.Value*pi/180;
     txtSx:=FSEScaleX.Value;
     txtSy:=FSEScaleY.Value;

     transminusM:=ident;
     transminusM.eDx:=-x;
     transminusM.eDy:=-y;

     scaleM:=ident;
     scaleM.eM11:=txtSx;
     scaleM.eM22:=txtSy;

     obliqueM:=ident;
     if txtOblique<>0 then
                          obliqueM.eM21:=-cotan(txtOblique)
                      else
                          obliqueM.eM21:=0;


     rotateM:=ident;
     rotateM.eM11:=cos(txtRotate);
     rotateM.eM12:=-sin(txtRotate);
     rotateM.eM21:=sin(txtRotate);
     rotateM.eM22:=cos(txtRotate);

     transplusM:=ident;
     transplusM.eDx:=x;
     transplusM.eDy:=y;

     SetGraphicsMode(TPanel(Sender).canvas.Handle, GM_ADVANCED );

     ModifyWorldTransform(TPanel(Sender).canvas.Handle,transminusM,MWT_Mode);
     ModifyWorldTransform(TPanel(Sender).canvas.Handle,scaleM,MWT_Mode);
     ModifyWorldTransform(TPanel(Sender).canvas.Handle,obliqueM,MWT_Mode);
     ModifyWorldTransform(TPanel(Sender).canvas.Handle,rotateM,MWT_Mode);
     ModifyWorldTransform(TPanel(Sender).canvas.Handle,transplusM,MWT_Mode);

     GetWorldTransform(TPanel(Sender).canvas.Handle, ResultTransform);


     ExtTextOut(TPanel(Sender).canvas.Handle,100,100,{Options: Longint}0,@r,'This is not OpenGost Type B TT',-1,nil);

     ModifyWorldTransform(TPanel(Sender).canvas.Handle, transminusM, MWT_IDENTITY);
     SetGraphicsMode(TPanel(Sender).canvas.Handle, GM_COMPATIBLE );
end;

procedure TForm1._onCreate(Sender: TObject);
var
  r:integer;
  s:string;
begin
     s:=ExtractFilePath(ParamStr(0))+'OpenGostTypeB-Regular.ttf';
     r:=AddFontResourceEx(@s[1],$10,nil);
end;

procedure TForm1._repaint(Sender: TObject);
begin
     Panel1.Invalidate;
end;

end.

